{
************************************************************
 Programme prototype pour exprimentations sur port joystick
 Aout 1998

 Version Delphi : Delphi 4

 Rmy Mallard
 25 rue de Provence
 78310 Maurepas - France

 Nota :
 Si vous possdez une version antrieure de Delphi (2 ou 3),
 vous pouvez rutiliser la majorit du code ci-dessous.
 L'utilisation de TListAction demandera une petite rcriture
 du code en ce qui concerne l'activation et la dsactivation
 des menus ou bouttons, mais sera parfaitement ralisable. Le
 composant TListAction n'existe en effet pas dans les versions
 2 ou 3 de Delphi.
 Dernier point : le code peut bien sr tre amlior, et il y a
 peut tre des bugs qui m'ont chapps. Le code source est libre
 de droit, sauf si vous avez l'intention d'en utiliser tout ou
 partie pour un produit commercial. Dans ce cas, vous devrez
 demander l'autorisation crite  l'auteur.
************************************************************
}


unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Buttons, StdCtrls, Menus, Grids, ComCtrls, Spin, ActnList,
  ImgList, ToolWin;

type
  TfmPrincipale = class(TForm)
    Panel1: TPanel;
    PaintBox1: TPaintBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Timer1: TTimer;
    SaveDialog1: TSaveDialog;
    MainMenu1: TMainMenu;
    mnuFichier: TMenuItem;
    mnuOuvrir: TMenuItem;
    mnuSauverSous: TMenuItem;
    N1: TMenuItem;
    mnuQuitter: TMenuItem;
    mnuOptions: TMenuItem;
    mnuToutEffacer: TMenuItem;
    mnuAfficherImageTest: TMenuItem;
    GrilleValeurs: TStringGrid;
    pnlN1: TPanel;
    pnlN2: TPanel;
    pnlN3: TPanel;
    pnlN4: TPanel;
    pnlA1: TPanel;
    pnlA2: TPanel;
    pnlA3: TPanel;
    pnlA4: TPanel;
    ColorDialog1: TColorDialog;
    BarreStatut: TStatusBar;
    ActionList1: TActionList;
    mnuMoyennerMesures: TMenuItem;
    N3: TMenuItem;
    ToolBar1: TToolBar;
    btnOuvrir: TToolButton;
    btnSauverSous: TToolButton;
    ToolButton3: TToolButton;
    btnDemarrer: TToolButton;
    btnStopper: TToolButton;
    Analyse1: TMenuItem;
    mnuDemarrer: TMenuItem;
    mnuStopper: TMenuItem;
    ImageList1: TImageList;
    ActDemarrer: TAction;
    ActStopper: TAction;
    ActOuvrir: TAction;
    ActSauverSous: TAction;
    ActGenererPointsAleatoires: TAction;
    ActToutEffacer: TAction;
    ToolButton1: TToolButton;
    btnGenererAleatoire: TToolButton;
    btnToutEffacer: TToolButton;
    OpenDialog1: TOpenDialog;
    ActQuitter: TAction;
    ToolButton4: TToolButton;
    btnQuitter: TToolButton;
    N4: TMenuItem;
    mnuEnrAutoSurDD: TMenuItem;
    N5: TMenuItem;
    mnuPreferences: TMenuItem;
    Label9: TLabel;
    pnlFond: TPanel;
    procedure PaintBox1Paint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure pnlN1Click(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure mnuMoyennerMesuresClick(Sender: TObject);
    procedure ActDemarrerExecute(Sender: TObject);
    procedure ActStopperExecute(Sender: TObject);
    procedure ActGenererPointsAleatoiresExecute(Sender: TObject);
    procedure ActToutEffacerExecute(Sender: TObject);
    procedure ActSauverSousExecute(Sender: TObject);
    procedure ActOuvrirExecute(Sender: TObject);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ActQuitterExecute(Sender: TObject);
    procedure mnuEnrAutoSurDDClick(Sender: TObject);
    procedure mnuPreferencesClick(Sender: TObject);
  private
    { Dclarations prives}
    procedure InitGrilleValeurs;
    procedure EcrireGrille(grille: TStringGrid; nomFichier: TFileName);
    procedure LireGrille(grille: TStringGrid; nomFichier: TFileName);
    procedure DecalerPointsMesures;
    procedure EffectuerMesure;
    procedure EffacerBarreStatuts;
    procedure RaffraichirBarreStatut(i: integer);
    procedure DessinerPoints;
    procedure SauverImage(FileName: TFileName);
    procedure VerifierPlaceDisponible(lecteur: char);
    function NouveauNomFichier: TFileName;
    procedure SauverDonnees(FileName: TFileName);
  public
    { Dclarations publiques}
  end;

const
  CR = #13;

var
  fmPrincipale: TfmPrincipale;
  CheminApp: string;
  CompteurMesures: integer;         {variable utilise pour l'enregistrement automatique sur DD}
  CompteurAffichage: integer;       {variable utilise pour le raffraichissement cran}
  DessinerCurseur: boolean;
  CurseurXNouveau, CurseurXAncien: integer;

implementation

uses EnrAuto;

{$R *.DFM}

procedure TfmPrincipale.FormCreate(Sender: TObject);
begin
  CheminApp := extractFilePath(application.exeName);
  {remplissage de la grille contenant les valeurs, par des zros}
  InitGrilleValeurs;
end;

procedure TfmPrincipale.InitGrilleValeurs;
var
  col, row: integer;
begin
  {remplissage de la grille contenant les valeurs, par des zros}
  for row := 0 To 511 do
    for col := 0 to 8 do
      grilleValeurs.cells[col, row] := '0';
  {on raffraichit les courbes avec ces nouvelles valeurs - toutes  zro}
  PaintBox1Paint(nil);
end;

procedure TfmPrincipale.Timer1Timer(Sender: TObject);
begin
  {cette procdure est appele toutes les n millisecondes, n tant l'intervalle
  spcifi dans la proprit Interval du composant Timer1}

  {On dcalle toutes les mesures stockes dans la grille de mesures
  et on libre ainsi le dernier emplacement de la grille pour stocker les nouvelles valeurs}
  DecalerPointsMesures;

  {on va regarder l'tat des lignes du port joystick}
  EffectuerMesure;

  {on incrmente de 1 la valeur des compteurs utiliss pour le raffraichissement de l'cran
  et pour la sauvegarde automatique sur le disque dur}
  inc(CompteurAffichage);
  inc(CompteurMesures);

  {on regarde si la valeur du compteur pour le rafraichissement cran  atteint
  la valeur spcifie dans la boite de dialogue Options.
  Si oui, on rafraichi l'cran et on remet le compteur  zro.}
  if CompteurAffichage >= fmOptions.spinRaffraichissementEcran.Value then begin
    PaintBox1Paint(Timer1);
    CompteurAffichage := 0;
  end;
end;

procedure TfmPrincipale.PaintBox1Paint(Sender: TObject);
begin
  {cette procdure est appele quand windows indique  l'application qu'une partie
  ou la totalit de l'interface graphique doit tre redessine. A plusieurs endroits
  du programme, nous appellerons explicitement cette procdure pour forcer le
  raffraichissement du composant PaintBox1 contenant les courbes}
  if sender <> Timer1 then EffacerBarreStatuts;
  DessinerPoints;
end;

procedure TfmPrincipale.EffacerBarreStatuts;
var
  i: integer;
begin
  for i := 0 to 8 do BarreStatut.panels[i].text := '';
end;

procedure TfmPrincipale.DecalerPointsMesures;
var
  row, col: integer;
begin
  { chaque ligne (row) du composant grilleValeurs, on donne la valeur
  de la ligne suivante, ce qui a pour effet un dcallage des mesures vers le haut}
  for row := 0 To 511 do
    for col := 0 to 8 do
      grilleValeurs.cells[col, row] := grilleValeurs.cells[col, row + 1];
end;

procedure TfmPrincipale.EffectuerMesure;
var
  ValeurEntree: byte;
  ValeurSortie: smallint;
  limite: integer;
  A1Val, A2Val, A3Val, A4Val, valTemp, i: integer;
  A1Stopped, A2Stopped, A3Stopped, A4Stopped: boolean;
begin
  A1Val := 0;
  A2Val := 0;
  A3Val := 0;
  A4Val := 0;
  A1Stopped := false;
  A2Stopped := false;
  A3Stopped := false;
  A4Stopped := false;
  ValeurSortie := 0;
  ValeurEntree := 0;

  {criture sur le port joystick pour remise  zro des compteurs}
  try
    asm
      mov dx, 0201h
      mov ax, ValeurSortie
      out dx, al
    end;
  except
    ActStopper.execute;
    exit;
  end;

  {lecture en boucle sur le port joystick.
  On sort de la boucle de lecture quand les quatre entres sont toutes actives
  ou quand le compteur Limite a atteind son maximum. Cette astuce permet de mesurer
  les quatre entres analogiques en une tape.}
  limite := 0;
  try
    repeat
      asm
        mov dx, 0201h
        in al, dx
        mov ValeurEntree, al
      end;
      if (((ValeurEntree and 1) div 1) = 0) then A1Stopped := true;
      if (((ValeurEntree and 2) div 2) = 0) then A2Stopped := true;
      if (((ValeurEntree and 4) div 4) = 0) then A3Stopped := true;
      if (((ValeurEntree and 8) div 8) = 0) then A4Stopped := true;
      if not A1Stopped then inc(A1Val);
      if not A2Stopped then inc(A2Val);
      if not A3Stopped then inc(A3Val);
      if not A4Stopped then inc(A4Val);
      inc(limite);
    until (limite > 1000) or (A1Stopped and A2Stopped and A3Stopped and A4Stopped);
  except
    ActStopper.execute;
    exit;
  end;

  {on inscrit les valeurs des entres numriques - D0  D3 - dans les colonnes
  0  3 de GrilleValeurs}
  GrilleValeurs.cells[0, 511] := intToStr(((ValeurEntree and 16) div 16) xor 1);
  GrilleValeurs.cells[1, 511] := intToStr(((ValeurEntree and 32) div 32) xor 1);
  GrilleValeurs.cells[2, 511] := intToStr(((ValeurEntree and 64) div 64) xor 1);
  GrilleValeurs.cells[3, 511] := intToStr(((ValeurEntree and 128) div 128) xor 1);

  {on inscrit les valeurs des entres analogiques - A0  A3 - dans dans les colonnes
  4  7 de GrilleValeurs}
  {s'il est demand un moyennage...}
  if mnuMoyennerMesures.checked then begin
    valTemp := 0;
    for i := 1 to fmOptions.spinMoyennage.Value do
      valTemp := valTemp + strToInt(GrilleValeurs.cells[4, 511 - i]);
    GrilleValeurs.cells[4, 511] := intToStr(((A1Val div 2) + valTemp) div (fmOptions.spinMoyennage.Value + 1));
    valTemp := 0;
    for i := 1 to fmOptions.spinMoyennage.Value do
      valTemp := valTemp + strToInt(GrilleValeurs.cells[5, 511 - i]);
    GrilleValeurs.cells[5, 511] := intToStr(((A2Val div 2) + valTemp) div (fmOptions.spinMoyennage.Value + 1));
    valTemp := 0;
    for i := 1 to fmOptions.spinMoyennage.Value do
      valTemp := valTemp + strToInt(GrilleValeurs.cells[6, 511 - i]);
    GrilleValeurs.cells[6, 511] := intToStr(((A3Val div 2) + valTemp) div (fmOptions.spinMoyennage.Value + 1));
    valTemp := 0;
    for i := 1 to fmOptions.spinMoyennage.Value do
      valTemp := valTemp + strToInt(GrilleValeurs.cells[7, 511 - i]);
    GrilleValeurs.cells[7, 511] := intToStr(((A4Val div 2) + valTemp) div (fmOptions.spinMoyennage.Value + 1));
  {s'il n'est pas demand de moyennage}
  end else begin
    GrilleValeurs.cells[4, 511] := intToStr(A1Val div 2);
    GrilleValeurs.cells[5, 511] := intToStr(A2Val div 2);
    GrilleValeurs.cells[6, 511] := intToStr(A3Val div 2);
    GrilleValeurs.cells[7, 511] := intToStr(A4Val div 2);
  end;

  {Hordatage : inscription du jour et de l'heur dans la dernire colone de GrilleValeurs}
  GrilleValeurs.cells[8, 511] := dateToStr(now) + ' ' + timeToStr(now);

  {Enregistrement automatique sur disque dur ? Si le menu correspondant est coch
  et si on en est  la mesure N 500, on enregistre les 512 dernires mesures
  sur le disque dur. On a donc un chevauchement de 12 mesures entre chaque enregistrement,
  chevauchement que vous pouvez supprimer si vous le dsirez en changeant la valeur de
  comparaison avec compteurMesures. La fonction NouveauNomFichier retourne un nom
  de fichier qui n'existe pas encore et qui suit le dernier cr. Aprs enregistrement,
  on vrifie si le disque dur possde autant de place libre que la valeur spcifie
  dans la fentre Options, et qui est par dfaut de 5 MO (5000 KO). Si la place disponible
  vient  manquer, le logiciel dsactive de lui mme l'option Enregistrement automatique.}
  if mnuEnrAutoSurDD.checked then begin
    if CompteurMesures >= 500 then begin
      CompteurMesures := 0;
      SauverDonnees(NouveauNomFichier);
      VerifierPlaceDisponible(fmOptions.lecteur.drive);
    end;
  end;

  {on indique dans la barre de statuts les dernires mesures releves, prsentes 
  la dernire ligne de GrilleValeurs, soit la ligne 511 - il y a 512 lignes et
  on commence par 0}
  RaffraichirBarreStatut(511);
end;

procedure TfmPrincipale.VerifierPlaceDisponible(lecteur: char);
var
  freeSpace: integer;
begin
  {la place disponible sur le disque indiqu par la variable Lecteur, est donne
  en octets. On la divise donc par 1024 pour l'avoir en KO}
  if lecteur in ['a'..'z'] then dec(lecteur, $20);
  freeSpace := diskFree(ord(lecteur) - $40);
  if (freeSpace div 1024) < fmOptions.spinEspaceRequis.value then
    mnuEnrAutoSurDD.checked := false;
end;

function TfmPrincipale.NouveauNomFichier: TFileName;
var
  NewFileNum: integer;
  dir, sFile: string;
begin
  {pour l'enregistrement automatique.
  On commence par regarder si le fichier 'x0000000.dat' existe. S'il n'existe pas,
  on ne vas pas plus loin et on garde ce nom. S'il existe, on entre dans une boucle
  o on dtermine un nom de fichier commancant toujours par la lettre x mais dont le
  reste des caractres est reprsent pa un nombre variable. On reste dans la boucle
  tant que le nouveau nom de fichier existe. Ds qu'on en a un qui n'existe pas,
  on sort de la boucle et on le place dans le rsultat de la fonction. Dans le cas o
  on aurait enregistr 9999999 fichiers (!!!), on dsactive l'enregistrement automatique.}
  NewFileNum := 0;
  dir := fmOptions.repertoire.directory;
  if copy(dir, length(dir), 1) <> '\' then dir := dir + '\';
  sFile := dir + 'x0000000.dat';
  while fileExists(sFile) do begin
    inc(NewFileNum);
    if (NewFileNum > 9999998) then mnuEnrAutoSurDD.checked := false;
    sFile := dir + 'x' + format('%7s', [intToStr(NewFileNum)]) + '.dat';
    while pos(' ', sFile) > 0 do sFile[Pos(' ', sFile)] := '0';
  end;
  result := sFile;
end;

procedure TfmPrincipale.DessinerPoints;

  {simple conversion d'une chaine de caractres en entier, mais protge.
  Si la chaine ne peut tre convertie en entier, on envoi 0 comme rsultat.}
  function TraduireValeur(s: string): integer;
  begin
    try
      result := StrToInt(s);
    except
      result := 0;
    end;
  end;

var
  bmp: TBitmap;
  row, col,
  posX, posY,
  i, val: integer;
begin
  CurseurXAncien := -1;

  {l'affichage des points de mesures dans le composant paintBox1 va passer par
  la cration temporaire d'un bitmap en mmoire. Cel n'est pas indispensable
  mais acclre considrablement le raffraichissement de l'image dessine.
  On fait, on dessine dj tous les points de mesure sur le bitmap temporaire bmp,
  puis une fois que tout est dessin, on copie le dessin sur le canevas du
  composant PaintBox1}
  try
    bmp := TBitmap.create;
    bmp.Width := paintBox1.width;
    bmp.height := paintBox1.height;
    with bmp.canvas do begin

      {On rempli tout le fond avec la couleur du composant pnlFond}
      brush.color := pnlFond.Color;
      FillRect(Rect(0, 0, bmp.width, bmp.height));

      {on dessine en pointill - grace  Style = psDot - les sparateurs des voies}
      pen.Color := clSilver;
      pen.Style := psDot;
      for i := 1 to 4 do begin
        moveTo(0, i * 16);
        lineTo(bmp.width, i * 16);
      end;
      for i := 1 to 3 do begin
        moveTo(0, 64 + (i * 66));
        lineTo(bmp.width, 64 + (i * 66));
      end;

      {on regarde la couleur qui correspond  la voie qu va tre dessine}
      pen.Style := psSolid;
      for col := 0 to 7 do begin
        case col of
          0 : pen.color := pnlN1.color;
          1 : pen.color := pnlN2.color;
          2 : pen.color := pnlN3.color;
          3 : pen.color := pnlN4.color;
          4 : pen.color := pnlA1.color;
          5 : pen.color := pnlA2.color;
          6 : pen.color := pnlA3.color;
          7 : pen.color := pnlA4.color;
        end;
        {on dessine la courbe de la voie reprsente par la valeur de Col}
        for row := 0 to 511 do begin
          val := TraduireValeur(grilleValeurs.cells[col, row]);
          posX := row;
          posY := 0;
          case col of
            0..3: begin
                    if val = 0 then posY := ((col) * 16) + 14
                    else if val = 1 then posY := ((col) * 16) + 2;
                  end;
            4..7: begin
                    posY := 64 + ((col - 4) * 66) + 64 - (val div 4);
                  end;
          end;
          if row = 0 then moveTo(posX, posY)
          else lineTo(posX, posY);
        end;
      end;

      {dessin du curseur vertical si on a cliqu sur le dessin}
      if DessinerCurseur then begin
        pen.style := psSolid;
        pen.Mode := pmXOr;
        moveTo(CurseurXAncien, 0);
        lineTo(CurseurXAncien, bmp.height);
        moveTo(CurseurXNouveau, 0);
        lineTo(CurseurXNouveau, bmp.height);
        CurseurXAncien := CurseurXNouveau;
      end;
    end;

    {copie du dessin effectu sur bmp et termin, sur le canevas du composant PaintBox1}
    paintBox1.canvas.draw(0, 0, bmp);

  finally
    bmp.free;
  end;
end;

procedure TfmPrincipale.SauverImage(FileName: TFileName);
var
  bmp: TBitmap;
  RectOrigine, RectDest: TRect;
begin
  {sauvegarde du dessin des courbes dans le format bitmap.
  A noter que vous pouvez  tout moment changer la couleur de fond
  sans altrer les donnes. Si vous voulez imprimer le dessin des courbes,
  prfrez un fond blanc et des courbes fonces pour conomiser l'encre
  de votre imprimante}
  {la sauvegarde du dessin passe par la cration d'un bitmap temporaire,
  sur lequel on copie le contenu de paintBox1, et dont on utilise ensuite
  tout simplement la fonction SaveToFile pour l'criture sur disque.}
  RectOrigine := Rect(0, 0, paintBox1.width, paintBox1.height);
  RectDest := Rect(1, 1, paintBox1.width + 1, paintBox1.height + 1);
  try
    bmp := TBitmap.create;
    bmp.Width := paintBox1.width + 2;
    bmp.height := paintBox1.height + 2;
    PaintBox1Paint(nil);
    bmp.Canvas.CopyRect(RectDest, paintBox1.Canvas, RectOrigine);
    bmp.saveToFile(fileName);
  finally
    bmp.free;
  end;
end;

procedure TfmPrincipale.SauverDonnees(FileName: TFileName);
begin
  {sauvegarde des donnes dans un format texte, et donc moins volumineux que
  le format bitmap}
  EcrireGrille(GrilleValeurs, fileName);
end;

procedure TfmPrincipale.pnlN1Click(Sender: TObject);
begin
  {cette procdure peut tre appele par l'un des neuf composants TPanel de
  choix de couleur (8 pour les voies de mesure et 1 pour la couleur du fond).
  Si Timer1 est actif - mesures en cours, on ne permet pas la modification
  des couleurs}
  if Timer1.enabled then exit;
  with ColorDialog1 do begin
    color := (sender as TPanel).color;
    if not execute then exit;
    (sender as TPanel).color := color;
  end;
  PaintBox1Paint(nil);
end;

procedure TfmPrincipale.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  {procdure appele quand on clique sur une des courbes pour faire apparaitre
  les valeurs dans la barre de statut situe en bas de la fentre}
  DessinerCurseur := true;
  CurseurXNouveau := x;
  PaintBox1Paint(nil);
  RaffraichirBarreStatut(x);
end;

procedure TfmPrincipale.RaffraichirBarreStatut(i: integer);
begin
  {on raffraichi la barre de statuts en y placant les valeurs contenues
  dans GrilleValeurs  la ligne N i }
  BarreStatut.panels[0].text := GrilleValeurs.cells[8, i];
  BarreStatut.panels[1].text := 'N1 = ' + GrilleValeurs.cells[0, i];
  BarreStatut.panels[2].text := 'N2 = ' + GrilleValeurs.cells[1, i];
  BarreStatut.panels[3].text := 'N3 = ' + GrilleValeurs.cells[2, i];
  BarreStatut.panels[4].text := 'N4 = ' + GrilleValeurs.cells[3, i];
  BarreStatut.panels[5].text := 'A1 = ' + GrilleValeurs.cells[4, i];
  BarreStatut.panels[6].text := 'A2 = ' + GrilleValeurs.cells[5, i];
  BarreStatut.panels[7].text := 'A3 = ' + GrilleValeurs.cells[6, i];
  BarreStatut.panels[8].text := 'A4 = ' + GrilleValeurs.cells[7, i];
end;

procedure TfmPrincipale.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  DessinerCurseur := false;
end;

procedure TfmPrincipale.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  {interdiction de quitter l'application si des mesures sont en cours}
  canClose := not timer1.enabled;
end;

procedure TfmPrincipale.mnuMoyennerMesuresClick(Sender: TObject);
begin
  mnuMoyennerMesures.checked := not mnuMoyennerMesures.checked;
end;

procedure TfmPrincipale.ActDemarrerExecute(Sender: TObject);
begin
  {desactivation de certains boutons ou menus ds qu'on dmarre une srie de mesures}
  ActQuitter.enabled := false;
  ActSauverSous.enabled := false;
  ActOuvrir.enabled := false;
  ActDemarrer.enabled := false;
  ActStopper.enabled := true;
  mnuPreferences.enabled := false;
  {mise  zro de tous les compteurs}
  CompteurAffichage := 0;
  CompteurMesures := 0;
  {activation du timer Timer1}
  Timer1.enabled := true;
end;

procedure TfmPrincipale.ActStopperExecute(Sender: TObject);
begin
  {ractivation des boutons et menus dsactivs au dmarrage d'une srie de mesures}
  ActQuitter.enabled := true;
  ActSauverSous.enabled := true;
  ActOuvrir.enabled := true;
  ActStopper.enabled := false;
  ActDemarrer.enabled := true;
  mnuPreferences.enabled := true;
  {dsactivation du timer Timer1}
  Timer1.enabled := false;
  {rafraichissement des courbes}
  PaintBox1Paint(nil);
end;

procedure TfmPrincipale.ActGenererPointsAleatoiresExecute(Sender: TObject);
var
  i: integer;
  date, msg: string;
begin
  msg := 'Attention !' + CR +
         'Cette fonction effacera les donnes actuellement en mmoire.' + CR +
         'Voulez-vous continuer ?';
  if messageDlg(msg, mtConfirmation, [mbYes, mbNo], 0) <> mrYes then exit;

  {remplissage de GrilleValeurs avec des points de mesures alatoires}
  date := dateToStr(now) + ' ' + timeToStr(now);
  for i := 0 to 511 do begin
    grilleValeurs.cells[0, i] := intToStr(random(2));
    grilleValeurs.cells[1, i] := intToStr(random(2));
    grilleValeurs.cells[2, i] := intToStr(random(2));
    grilleValeurs.cells[3, i] := intToStr(random(2));
    grilleValeurs.cells[4, i] := intToStr(12 + random(233));
    grilleValeurs.cells[5, i] := intToStr(24 + random(220));
    grilleValeurs.cells[6, i] := intToStr(12 + random(233));
    grilleValeurs.cells[7, i] := intToStr(24 + random(220));
    grilleValeurs.cells[8, i] := date;
  end;
  PaintBox1Paint(nil);
end;

procedure TfmPrincipale.ActToutEffacerExecute(Sender: TObject);
var
  msg: string;
begin
  msg := 'Attention !' + CR +
         'Cette fonction effacera les donnes actuellement en mmoire.' + CR +
         'Voulez-vous continuer ?';
  if messageDlg(msg, mtConfirmation, [mbYes, mbNo], 0) <> mrYes then exit;

  {remplissage de GrilleValeurs avec des points de mesures gaux  zro}
  InitGrilleValeurs;
end;

procedure TfmPrincipale.ActSauverSousExecute(Sender: TObject);
begin
  {on regarde si l'utilisateur veut enregistrer les courbes en bitmap
  ou en format de donnes}
  with SaveDialog1 do begin
    if execute then begin
      case filterIndex of
        1 : begin defaultExt := 'dat'; SauverDonnees(fileName); end;
        2 : begin defaultExt := 'bmp'; SauverImage(fileName); end;
      end;
    end;
  end;
end;

procedure TfmPrincipale.ActOuvrirExecute(Sender: TObject);
begin
  {ouverture d'une squence de mesures enregistre au format de donnes}
  with OpenDialog1 do begin
    if execute then begin
      LireGrille(GrilleValeurs, fileName);
      PaintBox1Paint(nil);
    end;
  end;
end;

procedure TfmPrincipale.EcrireGrille(grille: TStringGrid; nomFichier: TFileName);
var
  f: system.text;
  sRow, sCol : string;
  i, row, col : integer;
begin
  {criture du contenu de grilleValeurs dans un fichier de type texte}
  i := 0;
  try
    assignFile(F, nomFichier);
    rewrite(F);
    for row := 0 to grille.rowCount - 1 do
    begin
      if grille.cells[0, row] = '' then continue;
      sRow := '[Ligne=' + intToStr(i) + ']';
      writeLn(f, sRow);
      inc(i);
      for col := 0 to grille.colCount - 1 do
      begin
        sCol := grille.cells[col, row];
        writeLn(f, sCol);
      end;
    end;
  finally
    closeFile(f);
  end;
end;

procedure TfmPrincipale.LireGrille(grille: TStringGrid; nomFichier: TFileName);
var
  f: system.text;
  s : string;
  row, col : integer;
begin
  {remplissage du contenu de grilleValeurs avec les donnes contenues dans
  un fichier de type de donnes}
  if not fileExists(nomFichier) then
  begin
    messageDlg('Fichier inexistant!', mtError, [mbOK], 0);
    exit;
  end;
  row := 0;
  col := 0;
  try
    assignFile(f, nomFichier);
    reset(f);
    while not EOF(f) do
    begin
      readLn(f, s);
      if copy(s, 1, 1) = '[' then
      begin
        row := strToInt(copy(s, 8, length(s) - 8));
        if row + 1 > grille.rowCount then grille.rowCount := row + 1;
        col := 0;
        continue;
      end;
      grille.cells[col, row] := s;
      inc(col);
      if col + 1 > grille.colCount then grille.colCount := col + 1;
    end;
  finally
    closeFile(f);
  end;
end;

procedure TfmPrincipale.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  {redessin du curseur vertical pendant le dplacement de la souris sur paintBox1,
  si le bouton gauche de la souris est enfonc}
  if not DessinerCurseur then exit;;
  CurseurXNouveau := x;
  PaintBox1Paint(nil);
  RaffraichirBarreStatut(x);
end;

procedure TfmPrincipale.ActQuitterExecute(Sender: TObject);
begin
  close;
end;

procedure TfmPrincipale.mnuEnrAutoSurDDClick(Sender: TObject);
begin
  mnuEnrAutoSurDD.checked := not mnuEnrAutoSurDD.checked;
  CompteurMesures := 0;
end;

procedure TfmPrincipale.mnuPreferencesClick(Sender: TObject);
begin
  {appel de la fentre d'options}
  fmOptions.showModal;
  timer1.interval := fmOptions.spinIntervaleMesure.value;
end;

end.
